var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import Icon from '../Icon';
import Button from '../Button';

import buttonColors from '../../utils/buttonColors';

var ButtonWithLoader = (_temp2 = _class = function (_Component) {
  _inherits(ButtonWithLoader, _Component);

  function ButtonWithLoader() {
    var _temp, _this, _ret;

    _classCallCheck(this, ButtonWithLoader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: false,
      loaded: false,
      error: false
    }, _this.isUnmounted = false, _this.handleLoad = function (e) {
      return _this.beforeLoading().then(function () {
        return !_this.isUnmounted && _this.props.onClick(e);
      }).then(function (res) {
        return !_this.isUnmounted && _this.afterLoading(res);
      }).then(function (res) {
        return !_this.isUnmounted && _this.props.onLoaded(res);
      }).catch(function (error) {
        if (!_this.isUnmounted) {
          _this.setState({ loading: false, loaded: false, error: error });
        }

        throw error;
      });
    }, _this.beforeLoading = function () {
      return new Promise(function (resolve) {
        return _this.setState({ loading: true, loaded: false, error: false }, resolve);
      });
    }, _this.afterLoading = function (res) {
      return new Promise(function (resolve) {
        return _this.setState({
          loading: false,
          loaded: true
        }, function () {
          return setTimeout(function () {
            return !_this.isUnmounted ? _this.setState({ loaded: false }, function () {
              return resolve(res);
            }) : resolve(res);
          }, 3000);
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ButtonWithLoader.prototype.componentWillUnmount = function componentWillUnmount() {
    this.isUnmounted = true;
  };

  ButtonWithLoader.prototype.render = function render() {
    var _props = this.props,
        color = _props.color,
        disabled = _props.disabled,
        messageOnLoading = _props.messageOnLoading,
        messageOnLoaded = _props.messageOnLoaded,
        messageOnError = _props.messageOnError,
        onClick = _props.onClick,
        onLoaded = _props.onLoaded,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['color', 'disabled', 'messageOnLoading', 'messageOnLoaded', 'messageOnError', 'onClick', 'onLoaded', 'children']);

    var _state = this.state,
        loading = _state.loading,
        loaded = _state.loaded,
        error = _state.error;


    return React.createElement(
      Button,
      _extends({}, props, {
        color: error ? 'danger' : color,
        disabled: disabled || loading,
        onClick: this.handleLoad
      }),
      error ? React.createElement(
        'span',
        { className: 'text-white' },
        messageOnError
      ) : null,
      loading && !error ? messageOnLoading : null,
      loaded && !error ? messageOnLoaded : null,
      !loading && !loaded && !error ? children : null
    );
  };

  return ButtonWithLoader;
}(Component), _class.defaultProps = {
  color: 'primary',
  disabled: false,
  messageOnLoading: React.createElement(Icon, { name: 'spinner', pulse: true, fixedWidth: true }),
  messageOnLoaded: React.createElement(Icon, { name: 'check', fixedWidth: true }),
  messageOnError: React.createElement(Icon, { name: 'exclamation-triangle', fixedWidth: true }),
  onClick: function onClick() {},
  onLoaded: function onLoaded() {},
  children: null
}, _temp2);
ButtonWithLoader.propTypes = process.env.NODE_ENV !== "production" ? {
  color: PropTypes.oneOf(buttonColors),
  disabled: PropTypes.bool,
  messageOnLoading: PropTypes.node,
  messageOnLoaded: PropTypes.node,
  messageOnError: PropTypes.node,
  onClick: PropTypes.func,
  onLoaded: PropTypes.func,
  children: PropTypes.node
} : {};


export default ButtonWithLoader;