var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import Icon from '../Icon';
import Input from '../Input';

import buttonColors from '../../utils/buttonColors';

var ButtonWithUploader = (_temp2 = _class = function (_Component) {
  _inherits(ButtonWithUploader, _Component);

  function ButtonWithUploader() {
    var _temp, _this, _ret;

    _classCallCheck(this, ButtonWithUploader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      uploading: false,
      uploaded: false,
      error: false
    }, _this.isUnmounted = false, _this.selectFile = function (e) {
      if (!e.target.files.length) {
        return;
      }

      var name = _this.props.name;

      var formData = new FormData();
      formData.append(name, e.target.files[0]);

      _this.handleUpload(formData);
    }, _this.handleUpload = function (data) {
      return _this.beforeUploading().then(function () {
        return !_this.isUnmounted && _this.props.onUpload(data);
      }).then(function (res) {
        return !_this.isUnmounted && _this.afterUploading(res);
      }).then(function (res) {
        return !_this.isUnmounted && _this.props.onUploaded(res);
      }).catch(function (error) {
        if (!_this.isUnmounted) {
          _this.setState({ uploading: false, uploaded: false, error: error });
        }

        throw error;
      });
    }, _this.beforeUploading = function () {
      return new Promise(function (resolve) {
        return _this.setState({ uploading: true, error: false }, resolve);
      });
    }, _this.afterUploading = function (res) {
      return new Promise(function (resolve) {
        return _this.setState({
          uploading: false,
          uploaded: true
        }, function () {
          return setTimeout(function () {
            return !_this.isUnmounted ? _this.setState({ uploaded: false }, function () {
              return resolve(res);
            }) : resolve(res);
          }, 3000);
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ButtonWithUploader.prototype.componentWillUnmount = function componentWillUnmount() {
    this.isUnmounted = true;
  };

  ButtonWithUploader.prototype.render = function render() {
    var _props = this.props,
        id = _props.id,
        color = _props.color,
        messageOnUploading = _props.messageOnUploading,
        messageOnUploaded = _props.messageOnUploaded,
        messageOnError = _props.messageOnError,
        onUpload = _props.onUpload,
        onUploaded = _props.onUploaded,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['id', 'color', 'messageOnUploading', 'messageOnUploaded', 'messageOnError', 'onUpload', 'onUploaded', 'children']);

    var _state = this.state,
        uploading = _state.uploading,
        uploaded = _state.uploaded,
        error = _state.error;


    return React.createElement(
      Input.File,
      _extends({}, props, {
        id: 'upload_' + id,
        color: error ? 'danger' : color,
        onChange: this.selectFile
      }),
      error ? React.createElement(
        'span',
        { className: 'text-white' },
        messageOnError
      ) : null,
      uploading && !error ? messageOnUploading : null,
      uploaded && !error ? messageOnUploaded : null,
      !uploading && !uploaded && !error ? children : null
    );
  };

  return ButtonWithUploader;
}(Component), _class.defaultProps = {
  color: 'primary',
  messageOnUploading: React.createElement(Icon, { name: 'spinner', pulse: true, fixedWidth: true }),
  messageOnUploaded: React.createElement(Icon, { name: 'check', fixedWidth: true }),
  messageOnError: React.createElement(Icon, { name: 'exclamation-triangle', fixedWidth: true }),
  onUploaded: function onUploaded() {},
  children: null
}, _temp2);
ButtonWithUploader.propTypes = process.env.NODE_ENV !== "production" ? {
  id: PropTypes.string.isRequired,
  name: PropTypes.string.isRequired,
  color: PropTypes.oneOf(buttonColors),
  messageOnUploading: PropTypes.node,
  messageOnUploaded: PropTypes.node,
  messageOnError: PropTypes.node,
  onUpload: PropTypes.func.isRequired,
  onUploaded: PropTypes.func,
  children: PropTypes.node
} : {};


export default ButtonWithUploader;