var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';

import colors from '../../utils/colors';

var Text = function Text(_ref) {
  var color = _ref.color,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['color', 'className', 'children']);

  return React.createElement(
    'small',
    _extends({}, props, { className: 'form-text text-' + color + ' ' + className }),
    children
  );
};

Text.propTypes = process.env.NODE_ENV !== "production" ? {
  color: PropTypes.oneOf([].concat(colors, ['muted'])),
  className: PropTypes.string,
  children: PropTypes.node
} : {};

Text.defaultProps = {
  color: 'muted',
  className: '',
  children: null
};

export default Text;