var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import cn from 'classnames';
import Autocomplete from 'react-autocomplete';

var AutocompleteWrap = function AutocompleteWrap(_ref) {
  var innerRef = _ref.innerRef,
      props = _objectWithoutProperties(_ref, ['innerRef']);

  return React.createElement(Autocomplete, _extends({
    getItemValue: function getItemValue(item) {
      return item.name;
    },
    wrapperProps: { className: 'dropdown' },
    wrapperStyle: {},
    renderInput: function renderInput(_ref2) {
      var _ref2$className = _ref2.className,
          className = _ref2$className === undefined ? '' : _ref2$className,
          _ref2$size = _ref2.size,
          size = _ref2$size === undefined ? 'md' : _ref2$size,
          inputProps = _objectWithoutProperties(_ref2, ['className', 'size']);

      return React.createElement('input', _extends({}, inputProps, { className: cn('form-control', 'form-control-' + size, className) }));
    },
    renderMenu: function renderMenu(items) {
      return React.createElement(
        'div',
        { className: 'dropdown-menu ' + (items.length ? 'show' : '') },
        items
      );
    },
    renderItem: function renderItem(item, isHighlighted) {
      return React.createElement(
        'button',
        { key: item.value, className: 'dropdown-item ' + (isHighlighted ? 'active' : '') },
        item.name
      );
    }
  }, typeof innerRef === 'function' ? { ref: innerRef } : {}, props));
};

AutocompleteWrap.propTypes = process.env.NODE_ENV !== "production" ? {
  innerRef: PropTypes.func
} : {};

AutocompleteWrap.defaultProps = {
  innerRef: null
};

export default AutocompleteWrap;