var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import stylePropType from 'react-style-proptype';
import cn from 'classnames';

import buttonColors from '../../utils/buttonColors';
import sizes from '../../utils/sizes';

import './File.css';

var File = function File(_ref) {
  var id = _ref.id,
      color = _ref.color,
      outline = _ref.outline,
      size = _ref.size,
      disabled = _ref.disabled,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['id', 'color', 'outline', 'size', 'disabled', 'className', 'style', 'children']);

  return React.createElement(
    'label',
    {
      htmlFor: id,
      className: cn('btn', 'btn-file', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { disabled: disabled }, className),
      style: style
    },
    children,
    React.createElement('input', _extends({}, props, { id: id, type: 'file', disabled: disabled }))
  );
};

File.propTypes = process.env.NODE_ENV !== "production" ? {
  id: PropTypes.string.isRequired,
  color: PropTypes.oneOf(buttonColors),
  outline: PropTypes.bool,
  size: PropTypes.oneOf(sizes),
  disabled: PropTypes.bool,
  className: PropTypes.string,
  style: stylePropType,
  children: PropTypes.node
} : {};

File.defaultProps = {
  color: 'primary',
  outline: false,
  size: 'md',
  disabled: false,
  className: '',
  style: {},
  children: null
};

export default File;