var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';

import Item from './Item';

import './index.css';

var List = function List(_ref) {
  var Tag = _ref.tag,
      flush = _ref.flush,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['tag', 'flush', 'className', 'children']);

  return React.createElement(
    Tag,
    _extends({}, props, { className: 'list-group ' + (flush ? 'list-group-flush' : '') + ' ' + className }),
    children
  );
};

List.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  flush: PropTypes.bool,
  className: PropTypes.string,
  children: PropTypes.node
} : {};

List.defaultProps = {
  tag: 'ul',
  flush: false,
  className: '',
  children: null
};

List.Item = Item;

export default List;