var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

import sizes from '../../utils/sizes';

var Select = (_temp = _class = function (_Component) {
  _inherits(Select, _Component);

  function Select() {
    _classCallCheck(this, Select);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Select.prototype.render = function render() {
    var _props = this.props,
        items = _props.items,
        size = _props.size,
        className = _props.className,
        innerRef = _props.innerRef,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['items', 'size', 'className', 'innerRef', 'children']);

    return React.createElement(
      'select',
      _extends({}, props, {
        ref: typeof innerRef === 'function' ? innerRef : undefined,
        className: 'custom-select form-control-' + size + ' ' + className
      }),
      children || items.map(function (_ref, index) {
        var _ref$id = _ref.id,
            id = _ref$id === undefined ? '' : _ref$id,
            _ref$value = _ref.value,
            value = _ref$value === undefined ? '' : _ref$value,
            _ref$name = _ref.name,
            name = _ref$name === undefined ? '' : _ref$name,
            _ref$disabled = _ref.disabled,
            disabled = _ref$disabled === undefined ? false : _ref$disabled;
        return React.createElement(
          'option',
          { key: index, value: id || value, disabled: disabled },
          name
        );
      })
    );
  };

  return Select;
}(Component), _class.defaultProps = {
  items: [],
  size: 'md',
  className: '',
  innerRef: null,
  children: null
}, _temp);
Select.propTypes = process.env.NODE_ENV !== "production" ? {
  items: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    name: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    disabled: PropTypes.bool
  })),
  size: PropTypes.oneOf(sizes),
  className: PropTypes.string,
  innerRef: PropTypes.func,
  children: PropTypes.node
} : {};


export default Select;