'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Group = require('./Group');

var _Group2 = _interopRequireDefault(_Group);

var _buttonColors = require('../../utils/buttonColors');

var _buttonColors2 = _interopRequireDefault(_buttonColors);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = (_temp = _class = function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Button.prototype.render = function render() {
    var _props = this.props,
        tag = _props.tag,
        type = _props.type,
        active = _props.active,
        outline = _props.outline,
        color = _props.color,
        size = _props.size,
        className = _props.className,
        innerRef = _props.innerRef,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['tag', 'type', 'active', 'outline', 'color', 'size', 'className', 'innerRef', 'children']);

    var Tag = props.href && tag === 'button' ? 'a' : tag;

    var classNames = (0, _classnames2.default)('btn', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { active: active, disabled: props.disabled }, className);

    return _react2.default.createElement(
      Tag,
      _extends({}, props, {
        type: Tag === 'button' ? type : undefined,
        ref: typeof innerRef === 'function' ? innerRef : undefined,
        className: classNames
      }),
      children
    );
  };

  return Button;
}(_react.Component), _class.defaultProps = {
  tag: 'button',
  type: 'button',
  active: false,
  outline: false,
  color: 'primary',
  size: 'md',
  className: '',
  innerRef: null,
  children: null
}, _class.Group = _Group2.default, _temp);
Button.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  type: _propTypes2.default.string,
  active: _propTypes2.default.bool,
  outline: _propTypes2.default.bool,
  color: _propTypes2.default.oneOf(_buttonColors2.default),
  size: _propTypes2.default.oneOf(_sizes2.default),
  className: _propTypes2.default.string,
  innerRef: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};
exports.default = Button;
module.exports = exports['default'];