'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _ButtonWithLoader = require('../ButtonWithLoader');

var _ButtonWithLoader2 = _interopRequireDefault(_ButtonWithLoader);

var _PopupWithCard = require('../PopupWithCard');

var _PopupWithCard2 = _interopRequireDefault(_PopupWithCard);

var _buttonColors = require('../../utils/buttonColors');

var _buttonColors2 = _interopRequireDefault(_buttonColors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonWithConfirm = (_temp2 = _class = function (_Component) {
  _inherits(ButtonWithConfirm, _Component);

  function ButtonWithConfirm() {
    var _temp, _this, _ret;

    _classCallCheck(this, ButtonWithConfirm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      showConfirmPopup: false
    }, _this.isUnmounted = false, _this.handleClick = function (e) {
      _this.toggleConfirmPopup();
      _this.props.onClick(e);
    }, _this.handleConfirm = function () {
      return Promise.resolve().then(_this.props.onConfirm).then(_this.toggleConfirmPopup);
    }, _this.toggleConfirmPopup = function () {
      return !_this.isUnmounted && _this.setState({
        showConfirmPopup: !_this.state.showConfirmPopup
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ButtonWithConfirm.prototype.componentWillUnmount = function componentWillUnmount() {
    this.isUnmounted = true;
  };

  ButtonWithConfirm.prototype.render = function render() {
    var _props = this.props,
        confirmMessage = _props.confirmMessage,
        confirmButtonText = _props.confirmButtonText,
        confirmButtonColor = _props.confirmButtonColor,
        cancelButtonText = _props.cancelButtonText,
        onClick = _props.onClick,
        onConfirm = _props.onConfirm,
        props = _objectWithoutProperties(_props, ['confirmMessage', 'confirmButtonText', 'confirmButtonColor', 'cancelButtonText', 'onClick', 'onConfirm']);

    var showConfirmPopup = this.state.showConfirmPopup;


    return _react2.default.createElement(
      _react.Fragment,
      null,
      _react2.default.createElement(_Button2.default, _extends({}, props, { onClick: this.handleClick })),
      showConfirmPopup ? _react2.default.createElement(
        _PopupWithCard2.default,
        {
          key: 'popup',
          footer: _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _ButtonWithLoader2.default,
              { color: confirmButtonColor, onClick: this.handleConfirm },
              confirmButtonText
            ),
            _react2.default.createElement(
              _Button2.default,
              { color: 'light', className: 'ml-1', onClick: this.toggleConfirmPopup },
              cancelButtonText
            )
          ),
          className: 'text-left',
          onClose: this.toggleConfirmPopup
        },
        confirmMessage
      ) : null
    );
  };

  return ButtonWithConfirm;
}(_react.Component), _class.defaultProps = {
  confirmMessage: 'Are you sure?',
  confirmButtonText: 'Ok',
  confirmButtonColor: 'primary',
  cancelButtonText: 'Cancel',
  onClick: function onClick() {},
  onConfirm: function onConfirm() {}
}, _temp2);
ButtonWithConfirm.propTypes = process.env.NODE_ENV !== "production" ? {
  confirmMessage: _propTypes2.default.string,
  confirmButtonText: _propTypes2.default.string,
  confirmButtonColor: _propTypes2.default.oneOf(_buttonColors2.default),
  cancelButtonText: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onConfirm: _propTypes2.default.func
} : {};
exports.default = ButtonWithConfirm;
module.exports = exports['default'];