'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colors = require('../../utils/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Text = function Text(_ref) {
  var color = _ref.color,
      className = _ref.className,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['color', 'className', 'children']);

  return _react2.default.createElement(
    'small',
    _extends({}, props, { className: 'form-text text-' + color + ' ' + className }),
    children
  );
};

Text.propTypes = process.env.NODE_ENV !== "production" ? {
  color: _propTypes2.default.oneOf([].concat(_colors2.default, ['muted'])),
  className: _propTypes2.default.string,
  children: _propTypes2.default.node
} : {};

Text.defaultProps = {
  color: 'muted',
  className: '',
  children: null
};

exports.default = Text;
module.exports = exports['default'];