'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactAutocomplete = require('react-autocomplete');

var _reactAutocomplete2 = _interopRequireDefault(_reactAutocomplete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var AutocompleteWrap = function AutocompleteWrap(_ref) {
  var innerRef = _ref.innerRef,
      props = _objectWithoutProperties(_ref, ['innerRef']);

  return _react2.default.createElement(_reactAutocomplete2.default, _extends({
    getItemValue: function getItemValue(item) {
      return item.name;
    },
    wrapperProps: { className: 'dropdown' },
    wrapperStyle: {},
    renderInput: function renderInput(_ref2) {
      var _ref2$className = _ref2.className,
          className = _ref2$className === undefined ? '' : _ref2$className,
          _ref2$size = _ref2.size,
          size = _ref2$size === undefined ? 'md' : _ref2$size,
          inputProps = _objectWithoutProperties(_ref2, ['className', 'size']);

      return _react2.default.createElement('input', _extends({}, inputProps, { className: (0, _classnames2.default)('form-control', 'form-control-' + size, className) }));
    },
    renderMenu: function renderMenu(items) {
      return _react2.default.createElement(
        'div',
        { className: 'dropdown-menu ' + (items.length ? 'show' : '') },
        items
      );
    },
    renderItem: function renderItem(item, isHighlighted) {
      return _react2.default.createElement(
        'button',
        { key: item.value, className: 'dropdown-item ' + (isHighlighted ? 'active' : '') },
        item.name
      );
    }
  }, typeof innerRef === 'function' ? { ref: innerRef } : {}, props));
};

AutocompleteWrap.propTypes = process.env.NODE_ENV !== "production" ? {
  innerRef: _propTypes2.default.func
} : {};

AutocompleteWrap.defaultProps = {
  innerRef: null
};

exports.default = AutocompleteWrap;
module.exports = exports['default'];