'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactStyleProptype = require('react-style-proptype');

var _reactStyleProptype2 = _interopRequireDefault(_reactStyleProptype);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _buttonColors = require('../../utils/buttonColors');

var _buttonColors2 = _interopRequireDefault(_buttonColors);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

require('./File.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var File = function File(_ref) {
  var id = _ref.id,
      color = _ref.color,
      outline = _ref.outline,
      size = _ref.size,
      disabled = _ref.disabled,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['id', 'color', 'outline', 'size', 'disabled', 'className', 'style', 'children']);

  return _react2.default.createElement(
    'label',
    {
      htmlFor: id,
      className: (0, _classnames2.default)('btn', 'btn-file', 'btn-' + size, 'btn' + (outline ? '-outline' : '') + '-' + color, { disabled: disabled }, className),
      style: style
    },
    children,
    _react2.default.createElement('input', _extends({}, props, { id: id, type: 'file', disabled: disabled }))
  );
};

File.propTypes = process.env.NODE_ENV !== "production" ? {
  id: _propTypes2.default.string.isRequired,
  color: _propTypes2.default.oneOf(_buttonColors2.default),
  outline: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(_sizes2.default),
  disabled: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  style: _reactStyleProptype2.default,
  children: _propTypes2.default.node
} : {};

File.defaultProps = {
  color: 'primary',
  outline: false,
  size: 'md',
  disabled: false,
  className: '',
  style: {},
  children: null
};

exports.default = File;
module.exports = exports['default'];