'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Autocomplete = require('./Autocomplete');

var _Autocomplete2 = _interopRequireDefault(_Autocomplete);

var _File = require('./File');

var _File2 = _interopRequireDefault(_File);

var _Group = require('./Group');

var _Group2 = _interopRequireDefault(_Group);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var unstyledInputTypes = ['button', 'checkbox', 'file', 'hidden', 'image', 'radio', 'reset', 'submit', 'range'];

var Input = (_temp = _class = function (_Component) {
  _inherits(Input, _Component);

  function Input() {
    _classCallCheck(this, Input);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Input.prototype.render = function render() {
    var _props = this.props,
        size = _props.size,
        className = _props.className,
        innerRef = _props.innerRef,
        props = _objectWithoutProperties(_props, ['size', 'className', 'innerRef']);

    return _react2.default.createElement('input', _extends({}, props, typeof innerRef === 'function' ? { ref: innerRef } : {}, {
      className: (0, _classnames2.default)(!unstyledInputTypes.includes(props.type) && 'form-control form-control-' + size, className)
    }));
  };

  return Input;
}(_react.Component), _class.defaultProps = {
  type: 'text',
  size: 'md',
  className: '',
  innerRef: null
}, _class.Autocomplete = _Autocomplete2.default, _class.File = _File2.default, _class.Group = _Group2.default, _temp);
Input.propTypes = process.env.NODE_ENV !== "production" ? {
  type: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(_sizes2.default),
  className: _propTypes2.default.string,
  innerRef: _propTypes2.default.func
} : {};
exports.default = Input;
module.exports = exports['default'];