'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _colors = require('../../utils/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Class based component instead stateless functional, because refs needed.
// eslint-disable-next-line react/prefer-stateless-function
var Item = (_temp = _class = function (_Component) {
  _inherits(Item, _Component);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Item.prototype.render = function render() {
    var _cn;

    var _props = this.props,
        Tag = _props.tag,
        color = _props.color,
        active = _props.active,
        clickable = _props.clickable,
        disabled = _props.disabled,
        className = _props.className,
        onClick = _props.onClick,
        onToggle = _props.onToggle,
        toggleIconName = _props.toggleIconName,
        innerRef = _props.innerRef,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['tag', 'color', 'active', 'clickable', 'disabled', 'className', 'onClick', 'onToggle', 'toggleIconName', 'innerRef', 'children']);

    return _react2.default.createElement(
      Tag,
      _extends({}, typeof onClick === 'function' ? { role: 'presentation', onClick: onClick } : {}, props, {
        ref: typeof innerRef === 'function' ? innerRef : undefined,
        className: (0, _classnames2.default)('list-group-item', (_cn = {}, _cn['list-group-item-' + color] = color, _cn['list-group-item-action'] = typeof onClick === 'function' || clickable, _cn.toggled = typeof onToggle === 'function', _cn.active = active, _cn.disabled = disabled, _cn), className)
      }),
      typeof onToggle === 'function' ? _react2.default.createElement(
        _Button2.default,
        {
          color: active ? 'primary' : 'link',
          disabled: disabled,
          className: 'list-group-item-toggle',
          onClick: onToggle
        },
        _react2.default.createElement(_Icon2.default, { name: toggleIconName })
      ) : null,
      children
    );
  };

  return Item;
}(_react.Component), _class.defaultProps = {
  tag: 'li',
  color: '',
  active: false,
  clickable: false,
  disabled: false,
  className: '',
  onClick: null,
  onToggle: null,
  toggleIconName: 'plus',
  innerRef: null,
  children: null
}, _temp);
Item.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string]),
  color: _propTypes2.default.oneOf([''].concat(_colors2.default)),
  active: _propTypes2.default.bool,
  clickable: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onToggle: _propTypes2.default.func,
  toggleIconName: _propTypes2.default.string,
  innerRef: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};
exports.default = Item;
module.exports = exports['default'];