'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Spinner = require('../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loader = (_temp2 = _class = function (_Component) {
  _inherits(Loader, _Component);

  function Loader() {
    var _temp, _this, _ret;

    _classCallCheck(this, Loader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: _this.props.load,
      error: false
    }, _this.isUnmounted = false, _this.handleLoad = function (onLoad, onLoaded) {
      return _this.beforeLoading().then(function () {
        return !_this.isUnmounted && onLoad();
      }).then(function (res) {
        return !_this.isUnmounted && _this.afterLoading(res);
      }).then(function (res) {
        return !_this.isUnmounted && onLoaded(res);
      }).catch(function (error) {
        if (!_this.isUnmounted) {
          _this.setState({ loading: false, error: error });
        }

        throw error;
      });
    }, _this.beforeLoading = function () {
      return new Promise(function (resolve) {
        return _this.setState({ loading: true, error: false }, resolve);
      });
    }, _this.afterLoading = function (res) {
      return new Promise(function (resolve) {
        return _this.setState({ loading: false }, function () {
          return resolve(res);
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Loader.prototype.componentWillMount = function componentWillMount() {
    if (this.props.load) {
      this.handleLoad(this.props.onLoad, this.props.onLoaded);
    }
  };

  Loader.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (!this.state.loading && nextProps.reload) {
      this.handleLoad(nextProps.onLoad, nextProps.onLoaded);
    }
  };

  Loader.prototype.componentWillUnmount = function componentWillUnmount() {
    this.isUnmounted = true;
  };

  Loader.prototype.render = function render() {
    var _props = this.props,
        loadingIndicator = _props.loadingIndicator,
        children = _props.children;
    var _state = this.state,
        loading = _state.loading,
        error = _state.error;


    if (error) {
      return _react2.default.createElement(
        'div',
        { className: 'alert alert-danger mb-0', role: 'alert' },
        _react2.default.createElement(
          'samp',
          null,
          String(error)
        )
      );
    }

    if (!loading) {
      return children;
    }

    return loadingIndicator;
  };

  return Loader;
}(_react.Component), _class.defaultProps = {
  onLoad: function onLoad() {},
  onLoaded: function onLoaded() {},
  load: true,
  reload: false,
  loadingIndicator: _react2.default.createElement(_Spinner2.default, null),
  children: null
}, _temp2);
Loader.propTypes = process.env.NODE_ENV !== "production" ? {
  onLoad: _propTypes2.default.func,
  onLoaded: _propTypes2.default.func,
  load: _propTypes2.default.bool,
  reload: _propTypes2.default.bool,
  loadingIndicator: _propTypes2.default.node,
  children: _propTypes2.default.node
} : {};
exports.default = Loader;
module.exports = exports['default'];