'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Popup = function Popup(_ref) {
  var closeButtonTitle = _ref.closeButtonTitle,
      className = _ref.className,
      onClose = _ref.onClose,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['closeButtonTitle', 'className', 'onClose', 'children']);

  return _react2.default.createElement(
    'div',
    { className: 'popup' },
    _react2.default.createElement('button', { className: 'popup-close-bg', onClick: onClose, title: closeButtonTitle }),
    _react2.default.createElement(
      'div',
      { className: 'popup-content' },
      _react2.default.createElement(
        'div',
        _extends({ className: 'popup-body ' + className }, props),
        children
      )
    )
  );
};

Popup.propTypes = process.env.NODE_ENV !== "production" ? {
  closeButtonTitle: _propTypes2.default.string,
  className: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};

Popup.defaultProps = {
  closeButtonTitle: 'Close',
  className: '',
  onClose: function onClose() {},
  children: null
};

exports.default = Popup;
module.exports = exports['default'];