'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _colors = require('../../utils/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var PopupWithCard = function PopupWithCard(_ref) {
  var color = _ref.color,
      title = _ref.title,
      controls = _ref.controls,
      closeButtonTitle = _ref.closeButtonTitle,
      onClose = _ref.onClose,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['color', 'title', 'controls', 'closeButtonTitle', 'onClose', 'children']);

  return _react2.default.createElement(
    _Popup2.default,
    { closeButtonTitle: closeButtonTitle, onClose: onClose },
    _react2.default.createElement(
      _Card2.default,
      _extends({
        color: color,
        title: title,
        collapsible: false,
        controls: title || controls ? _react2.default.createElement(
          _react.Fragment,
          null,
          typeof controls === 'string' ? _react2.default.createElement(
            'div',
            null,
            controls
          ) : controls,
          _react2.default.createElement(
            _Button2.default,
            {
              color: color || 'light',
              className: 'ml-3',
              onClick: onClose,
              title: closeButtonTitle
            },
            _react2.default.createElement(_Icon2.default, { name: 'close' })
          )
        ) : null
      }, props),
      children
    )
  );
};

PopupWithCard.propTypes = process.env.NODE_ENV !== "production" ? {
  color: _propTypes2.default.oneOf([].concat(_colors2.default, [''])),
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  controls: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.node]),
  closeButtonTitle: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};

PopupWithCard.defaultProps = {
  color: '',
  title: null,
  controls: null,
  closeButtonTitle: 'Close',
  onClose: function onClose() {},
  children: null
};

exports.default = PopupWithCard;
module.exports = exports['default'];