'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _sizes = require('../../utils/sizes');

var _sizes2 = _interopRequireDefault(_sizes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = (_temp = _class = function (_Component) {
  _inherits(Select, _Component);

  function Select() {
    _classCallCheck(this, Select);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  Select.prototype.render = function render() {
    var _props = this.props,
        items = _props.items,
        size = _props.size,
        className = _props.className,
        innerRef = _props.innerRef,
        children = _props.children,
        props = _objectWithoutProperties(_props, ['items', 'size', 'className', 'innerRef', 'children']);

    return _react2.default.createElement(
      'select',
      _extends({}, props, {
        ref: typeof innerRef === 'function' ? innerRef : undefined,
        className: 'custom-select form-control-' + size + ' ' + className
      }),
      children || items.map(function (_ref, index) {
        var _ref$id = _ref.id,
            id = _ref$id === undefined ? '' : _ref$id,
            _ref$value = _ref.value,
            value = _ref$value === undefined ? '' : _ref$value,
            _ref$name = _ref.name,
            name = _ref$name === undefined ? '' : _ref$name,
            _ref$disabled = _ref.disabled,
            disabled = _ref$disabled === undefined ? false : _ref$disabled;
        return _react2.default.createElement(
          'option',
          { key: index, value: id || value, disabled: disabled },
          name
        );
      })
    );
  };

  return Select;
}(_react.Component), _class.defaultProps = {
  items: [],
  size: 'md',
  className: '',
  innerRef: null,
  children: null
}, _temp);
Select.propTypes = process.env.NODE_ENV !== "production" ? {
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    name: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    disabled: _propTypes2.default.bool
  })),
  size: _propTypes2.default.oneOf(_sizes2.default),
  className: _propTypes2.default.string,
  innerRef: _propTypes2.default.func,
  children: _propTypes2.default.node
} : {};
exports.default = Select;
module.exports = exports['default'];