'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _iconSizes = require('../../utils/iconSizes');

var _iconSizes2 = _interopRequireDefault(_iconSizes);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Spinner = function Spinner(_ref) {
  var size = _ref.size,
      inline = _ref.inline,
      className = _ref.className,
      iconName = _ref.iconName,
      props = _objectWithoutProperties(_ref, ['size', 'inline', 'className', 'iconName']);

  return _react2.default.createElement(
    'span',
    _extends({}, props, { className: (0, _classnames2.default)({ 'spinner-on-full-height': !inline }, className) }),
    _react2.default.createElement(_Icon2.default, { name: iconName, size: size, pulse: true })
  );
};

Spinner.propTypes = process.env.NODE_ENV !== "production" ? {
  size: _propTypes2.default.oneOf(_iconSizes2.default),
  inline: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  iconName: _propTypes2.default.string
} : {};

Spinner.defaultProps = {
  size: '3x',
  inline: false,
  className: '',
  iconName: 'spinner'
};

exports.default = Spinner;
module.exports = exports['default'];